// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "display/shader/SimpleBillboardedShader.hpp"
#include "SimpleBillboardedMaterial.hpp"
#include "game/DawnGame.hpp"

using namespace Dawn;

SimpleBillboardedMaterial::SimpleBillboardedMaterial(SceneItem *i) :
  Material(i)
{
}

void SimpleBillboardedMaterial::onStart() {
  this->shaderLock = this->getGame()->renderManager.getShaderManager()->lockShader<SimpleBillboardedShader>();
}

void SimpleBillboardedMaterial::onDispose() {
  this->getGame()->renderManager.getShaderManager()->releaseShader<SimpleBillboardedShader>(this->shaderLock);
}

Shader * SimpleBillboardedMaterial::getShader() {
  return this->getGame()->renderManager.getShaderManager()->getShader<SimpleBillboardedShader>(this->shaderLock);
}